# -*- coding: utf-8 -*-

import os
import html
import urllib
from wsgi import tools, http

def quote_searchword(searchword):
    return urllib.quote_plus(searchword).replace('+', '_').lower()
    
def unquote_searchword(searchword):
    words = urllib.unquote_plus(searchword).replace('_', ' ').split()
    result = []
    for word in words:
        result.append(word.capitalize())
    return ' '.join(result)

def list_dir(folder, continue_on_error=True):
    for f in os.listdir(folder):
        try:
            filename = os.path.join(folder, f)
            if f[0] == '.':
                continue
            if os.path.isdir(filename):
                for data in list_dir(filename, continue_on_error):
                    yield data
            elif os.path.isfile(filename):
                yield filename
        except OSError, IOError:
            if not continue_on_error:
                raise

def search(searchword):
    words = searchword.split(' ')
    cutln = len(os.path.realpath(os.path.dirname(__file__) + '/../pages')) + 1
    for f in list_dir(os.path.realpath(os.path.dirname(__file__) + '/../pages')):
        data = file(f).read()
        data2 = data[:]
        data = data.lower()
        found = True
        for word in words:
            if not word in data:
                found = False
                break
        if found:
            f = f[cutln:-4]
            title, content = html.parse(data2)
            yield (f, title)
        

def run(environ, start_response, parts):
    storage = tools.get_parameters(environ)
    
    if len(parts) > 1:
        searchword = unquote_searchword('/'.join(parts[1:]))
        start_response('200 OK', [('Content-Type', 'text/html')])
        yield html.header('Suchergebnisse', 'suche')
        yield '<h1>Suchergebnisse</h1>\n'
        yield '<p>Suchwort: <strong>%s</strong></p>\n' % searchword
        yield '<ul>\n'
        
        found = False
        for link, title in search(searchword.lower()):
            found = True
            yield '  <li><a href="%s?s=%s">%s</a></li>\n' % (
                '/%s/' % link, urllib.quote_plus(searchword.lower()), title)
        
        if not found:
            yield '  <li><strong>keine Seite gefunden</strong></li>\n'
        
        yield '</ul><p><a href="/suche/">Neue Suchabfrage</a></p>\n'
        yield html.footer()
        
    elif 'q' in storage:
        searchword = quote_searchword(storage['q'])
        http.path_redirect(environ, start_response, 'suche/' + searchword)
        return
    
    else:
        start_response('200 OK', [('Content-Type', 'text/html')])
        yield html.header('Suche', 'suche')
        yield '<h1>Suche</h1>\n'
        for line in [
            '<p>',
            'Gib einen Suchbegriff ein um die Webseite danach zu durchsuchen.'
            '</p>',
            '<form action="/suche/" method="get">',
            '<p><input type="text" name="q" size="30" />',
            '<input type="submit" value="Suchen" /></p>',
            '</form>'
        ]: yield line + '\n'
        yield html.footer()

